package cn.com.infosec.asn1.pkcs;

import cn.com.infosec.asn1.ASN1Encodable;
import cn.com.infosec.asn1.ASN1EncodableVector;
import cn.com.infosec.asn1.ASN1Sequence;
import cn.com.infosec.asn1.DERObject;
import cn.com.infosec.asn1.DERObjectIdentifier;
import cn.com.infosec.asn1.DERSequence;
import java.util.Enumeration;

public class PBES2Parameters extends ASN1Encodable implements PKCSObjectIdentifiers {
   private KeyDerivationFunc func;
   private EncryptionScheme scheme;

   public PBES2Parameters(ASN1Sequence obj) {
      ASN1Sequence var2;
      DERObjectIdentifier var3;
      Enumeration obj1;
      if ((var2 = (ASN1Sequence)(obj1 = obj.getObjects()).nextElement()).getObjectAt(0).equals(var3 = PKCSObjectIdentifiers.id_PBKDF2)) {
         this.func = new KeyDerivationFunc(var3, PBKDF2Params.getInstance(var2.getObjectAt(1)));
      } else {
         KeyDerivationFunc var5;
         var5 = new KeyDerivationFunc.<init>(var2);
         this.func = var5;
      }

      this.scheme = new EncryptionScheme((ASN1Sequence)obj1.nextElement());
   }

   public KeyDerivationFunc getKeyDerivationFunc() {
      return this.func;
   }

   public EncryptionScheme getEncryptionScheme() {
      return this.scheme;
   }

   public DERObject toASN1Object() {
      ASN1EncodableVector var1;
      ASN1EncodableVector var10000 = var1 = new ASN1EncodableVector;
      var1.<init>();
      var1.add(this.func);
      var10000.add(this.scheme);
      return new DERSequence(var1);
   }
}
